/*
	xms.C

	Version 1.0

	Extended Memory API Tester

	Copyright (C) 1993, Geoff Friesen B.Sc.
	All rights reserved.

	Developed with: Borland C++ 3.1
*/

/*
	set ti=c:\borlandc\tsr\tsrlib
	t xms -hx -i
*/

#if !defined(__TINY__)
#error Tiny Memory Model Expected
#endif

#include "tsrlib.H"

char *title = "\r\n"
	      "ͻ\r\n"
	      " XMS v1.0  Extended Memory API Tester   \r\n"
	      "                                         \r\n"
	      " Copyright (C) 1993, Geoff Friesen B.Sc. \r\n"
	      " All rights reserved.                    \r\n"
	      "ͼ\r\n"
	      "$";

#define	NCOLS	60
#define	NROWS	3

char buffer [(NCOLS+1)*(NROWS+1)*2];

int column = (80-NCOLS)/2;
int row = (25-NROWS)/2;

char *_uitoa (unsigned value, char *string);

void main (void)
{
   char buffer2 [6];
   int cshape, i, vmode, x, y;
   unsigned nkilos, maxblocksize;

   if ((vmode = v_getmode ()) != BW80 && vmode != C80 && vmode != MONO)
       return;

   cshape = v_getshape ();
   v_setshape (0x2000);         /* hide cursor */

   x = v_wherex ();
   y = v_wherey ();

   v_screen (SCREEN_SAVE, column, row, NCOLS+1, NROWS+1, buffer);

   v_setattr (LIGHTGRAY << 4);
   v_border (SINGLE_LINE, column, row, NCOLS, NROWS);
   v_shadow (column, row, NCOLS, NROWS);
   v_clear(column+1, row+1, NCOLS-2, NROWS-2);

   v_gotoxy (column+1, row+1);
   if (!XMS_Query (&nkilos, &maxblocksize))
       v_cputs ("XMS Driver not installed!");
   else
       v_cprintf ("Kilos = %5u (%x) & Max block size = %5u (%x)",
		  nkilos, nkilos, maxblocksize, maxblocksize);

   (void) k_fetch ();

   v_screen (SCREEN_RESTORE, column, row, NCOLS+1, NROWS+1, buffer);
   v_gotoxy (x, y);
   v_setshape (cshape);
}

#ifndef INCL_KFETCH
#include "kfetch.C"
#endif

#ifndef INCL_VBORDER
#include "vborder.C"
#endif

#ifndef INCL_VCPRINTF
#include "vcprintf.C"
#endif

#ifndef INCL_VCPUTS
#include "vcputs.C"
#endif

#ifndef INCL_VGETMODE
#include "vgetmode.C"
#endif

#ifndef INCL_VGETSHAPE
#include "vgetshap.C"
#endif

#ifndef INCL_VGOTOXY
#include "vgotoxy.C"
#endif

#ifndef INCL_VPAINT
#include "vpaint.C"
#endif

#ifndef INCL_VSCREEN
#include "vscreen.C"
#endif

#ifndef INCL_VSETATTR
#include "vsetattr.C"
#endif

#ifndef INCL_VSETSHAPE
#include "vsetshape.C"
#endif

#ifndef INCL_VSHADOW
#include "vshadow.C"
#endif

#ifndef INCL_VWHEREX
#include "vwherex.C"
#endif

#ifndef INCL_VWHEREY
#include "vwherey.C"
#endif